#!/usr/bin/env ruby
# ping.rb -- PING : ICMPModule example
# $Id: ping.rb,v 1.5 2000/10/31 19:54:20 gotoyuzo Exp $

require 'icmp'
require 'timeout'

include ICMPModule
include Socket::Constants

host = ARGV[0] || (STDERR.print "Usage: #$0 hostname\n"; exit)

ent = Socket::gethostbyname(host)
ips = "%d.%d.%d.%d" % [ ent[3][0], ent[3][1], ent[3][2], ent[3][3] ]
print "PING #{ent[0]} (#{ips})\n"

# open ICMP socket.
sock = ICMPSocket.new
sockaddr = make_sockaddr_in(AF_INET, 0, ent[3])

# make ICMP packet.
req = ICMP.new
req.icmp_type = ICMP_ECHO
req.icmp_code = 0
req.icmp_id = $$ & 0xffff

1.upto(5){ |i|
  buf = nil

  req.icmp_seq = i
  req.icmp_data = [ Time.now.to_f ].pack("d")
  req.setup # calc checksum and config packet length.

  sock.send(req, 0, sockaddr)
  begin
    timeout(5){ buf = sock.recv(65535) }
  rescue TimeoutError
    next
  end
  recv_time = Time.now.to_f
  iph, repl = ICMPModule.split(buf)

  if repl.icmp_type == ICMP_ECHOREPLY && repl.icmp_id == req.icmp_id
    send_time = repl.icmp_data.unpack("d")[0]
    rtt = (recv_time - send_time) * 1000
    print "%d bytes from %s: icmp_seq=%d ttl=%d time=%.3f ms\n" %
          [ repl.size, iph.ip_src, repl.icmp_seq, iph.ip_ttl, rtt ]
  end
  sleep 1
}
